import asyncio
import ssl


async def server_handle_echo(reader, writer):
    data = await reader.readuntil()
    writer.write(data)
    await writer.drain()
    writer.close()


async def client_send_echo(loop):
    ssl_context = ssl.create_default_context(ssl.Purpose.SERVER_AUTH, cafile='cert.pem')
    ssl_context.load_dh_params('dh2048.pem')
    # ssl_context.check_hostname = False
    reader, writer = await asyncio.open_connection(host='127.0.0.1', port=9876,
                                                   loop=loop, ssl=ssl_context)

    expected = b'meow\n'
    writer.write(expected)
    await writer.drain()
    actual = await reader.readuntil()
    print(actual == expected)
    writer.close()


def main():
    loop = asyncio.get_event_loop()

    ssl_context = ssl.create_default_context(ssl.Purpose.CLIENT_AUTH)
    ssl_context.load_cert_chain(certfile='cert.pem', keyfile='cert.pem')
    ssl_context.load_dh_params('dh2048.pem')
    server = asyncio.start_server(server_handle_echo, host='127.0.0.1', port=9876,
                                  ssl=ssl_context)
    loop.run_until_complete(server)

    client = client_send_echo(loop)
    loop.run_until_complete(client)


if __name__ == '__main__':
    main()
